
#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif
varying LOWP vec4 v_color;
varying vec2 v_texCoords;
uniform sampler2D u_texture;
uniform sampler2D u_UV;
uniform sampler2D u_UV2;

mat3 yuv_m3 = mat3(
    1.0, 1.0, 1.0, // first column (not row!)
    0.0,  -0.34414, 1.7720,  // second column
    1.40200, -0.71414, 0.0 // third column
);
mat3 yuv_m3_t = mat3(
        1.0, 1.40200, 0.0, // first column (not row!)
        1.0, 0.0,  1.7720, // third column
        1.0, -0.71414,-0.34414 // second column
);
mat4 fk = mat4 (
1.164,	1.164, 		1.164,	0.0,
0.0,	-0.391,		2.018,	0.0,
1.596,	-0.813,		0.0,	0.0,
-0.874164705882353, 0.5313254901960784, -1.085992156862745, 1.0
);

vec2 getUV()
{
    vec2 xy = mat2(0.0, 1.0, -1.0, 0.0) * (v_texCoords - vec2(0.5,0.5)) + vec2(0.5, 0.5);
    xy.y = 1.0 - xy.y;
    return xy;
}
vec2 getUV0()
{
    return v_texCoords;
}
void fkYUV() {
    vec2 xy = getUV();
    float y = texture2D(u_texture, xy).a;
    vec2 uv = texture2D(u_UV, xy).ba;

    vec4 c = vec4(y, uv.x, uv.y, 1.0);
    c = fk * c;
    gl_FragColor = v_color * clamp(c, 0.0, 1.0);
}
void yuv420P3() {
    vec2 xy = getUV0();
    float y = texture2D(u_texture, xy).a;
    float u = texture2D(u_UV, xy).a;
    float v = texture2D(u_UV2, xy).a;

    vec4 c = vec4(y, u, v, 1.0);
    c = fk * c;
    gl_FragColor = v_color * clamp(c, 0.0, 1.0);
}
void yuv420P3Old()
{
    vec2 xy = getUV0();
    float y = texture2D(u_texture, xy).a;
    float u = texture2D(u_UV, xy).a;
    float v = texture2D(u_UV2, xy).a;

    vec4 c = vec4(y, u-0.5, v-0.5, 1.0);
    c.rgb = yuv_m3 * c.rgb;
    gl_FragColor = v_color * clamp(c, 0.0, 1.0);
}
// nv21:
void mainNv21()
{
    vec2 xy = getUV();
	float y = texture2D(u_texture, xy).a;
	vec2 uv = texture2D(u_UV, xy).ba;

	vec4 c = vec4(y, uv.y-0.5, uv.x-0.5, 1.0);
	c.rgb = yuv_m3 * c.rgb;
    gl_FragColor = v_color * clamp(c, 0.0, 1.0);
}
// nv12:
void mainNv12()
{
    vec2 xy = getUV();
    float y = texture2D(u_texture, xy).a;
    vec2 uv = texture2D(u_UV, xy).ba;

    vec4 c = vec4(y, uv.x-0.5, uv.y-0.5, 1.0);
    c.rgb = yuv_m3 * c.rgb;
    gl_FragColor = v_color * clamp(c, 0.0, 1.0);
}
// only luminance
void main1()
{ // only luminance
    float l = texture2D(u_texture, v_texCoords).a;
    gl_FragColor = v_color * vec4(l, l, l, 1.0);
}

void main()
{
    mainNv21();
//    yuv420P3();
//    yuv420P3Old();
}