
#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif
varying LOWP vec4 v_color;
varying vec2 v_texCoords;
uniform sampler2D u_texture;
uniform sampler2D u_UV;
uniform sampler2D u_UV2;

mat3 yuv_m3 = mat3(
                1.0, 1.0, 1.0, // first column (not row!)
                0.0,  -0.34414, 1.7720,  // second column
                1.40200, -0.71414, 0.0 // third column
    );
mat3 yuv_m3_t = mat3(
        1.0, 1.40200, 0.0, // first column (not row!)
        1.0, 0.0,  1.7720, // third column
        1.0, -0.71414,-0.34414 // second column
);
vec2 convertUV()
{
    return v_texCoords;
}
void process(vec4 c)
{
    c.rgb = yuv_m3 * c.rgb;
    gl_FragColor = v_color * clamp(c, 0.0, 1.0);
}
void main()
{
    vec4 c;
    vec2 xy = convertUV();
    c.r = texture2D(u_texture, xy).a;
    c.g = texture2D(u_UV, xy).a;
    c.b = texture2D(u_UV2, xy).a;
    c.a = 1.0;
    process(c);
}